<?php

/* -------------------------------------------------------
 *
 *   LiveStreet (v1.x)
 *   Plugin Anti bot (v.0.1)
 *   Copyright © 2013 Bishovec Nikolay
 *
 * --------------------------------------------------------
 *
 *   Plugin Page: http://netlanc.net
 *   Contact e-mail: netlanc@yandex.ru
 *
 * ---------------------------------------------------------
 */

class PluginAb_ActionAjax extends PluginAb_Inherit_ActionAjax
{

    protected function RegisterEvent() {
        parent::RegisterEvent();
        $this->AddEventPreg('/^ab$/i', '/^setisbot$/', 'EventSetIsBot');
        $this->AddEventPreg('/^ab$/i', '/^deletetopics$/', 'EventDeleteTopics');

    }

    protected function EventSetIsBot() {

        if (!$this->oUserCurrent || !$this->oUserCurrent->isAdministrator()) {
            $this->Message_AddErrorSingle($this->Lang_Get('need_authorization'),$this->Lang_Get('error'));
            return;
        }

        $iUser = (int)getRequest('id');
        if (!($oUser = $this->User_GetUserById($iUser))){
            $this->Message_AddErrorSingle($this->Lang_Get('system_error'),$this->Lang_Get('error'));
            return;
        }

        $iIsBot = 1;
        if ($oUser->getIsBot()){
            $iIsBot = 0;
        }

        $oUser->setIsBot($iIsBot);
        $oUser->setProfileDate(date("Y-m-d H:i:s"));

        if ($this->User_UpdateUserIsBot($oUser)){
            $this->Viewer_AssignAjax('text',$oUser->getIsBot() ? $this->Lang_Get('plugin.ab.is_not_bot'):$this->Lang_Get('plugin.ab.is_bot'));
        } else {
            $this->Message_AddErrorSingle($this->Lang_Get('system_error'),$this->Lang_Get('error'));
        }

    }

    protected function EventDeleteTopics() {
        if (!$this->oUserCurrent || !$this->oUserCurrent->isAdministrator()) {
            $this->Message_AddErrorSingle($this->Lang_Get('need_authorization'),$this->Lang_Get('error'));
            return;
        }

        $iUser = (int)getRequest('id');
        if (!($oUser = $this->User_GetUserById($iUser))){
            $this->Message_AddErrorSingle($this->Lang_Get('system_error'),$this->Lang_Get('error'));
            return;
        }

        $aFilter = array(
            'user_id' => $oUser->getId()
        );

        $aTopics = $this->Topic_GetTopicsByFilter($aFilter, 1, 99999);
        $bOk = true;
        if (!empty($aTopics['collection'])){
            foreach ($aTopics['collection'] as $oTopic){
                $bOk = $bOk && $this->Topic_DeleteTopic($oTopic);
            }
        }

        if ($bOk){
            $this->Message_AddNoticeSingle($this->Lang_Get('plugin.ab.topics_deleted'),$this->Lang_Get('attention'));
        } else {
            $this->Message_AddErrorSingle($this->Lang_Get('system_error'),$this->Lang_Get('error'));
        }

    }

}

?>
